oscillographicShift = 0
oscillographSpeed = 70

function drawHeartbeat(dt,name,health, oxy, img, stats)	
	
	if health == 0 then oxy = 0 end
	if stats == nil then stats = {} end
	
	heartbeatImage = "MOD/imgs/heartbeat.PNG"
	oxygenImage = "MOD/imgs/oxygen.PNG"
	heartbeatMask = "MOD/imgs/heartbeatGradient.png"		

	UiPush()
		DrawSurroundingBackgroundBox()
		
		DrawPhotoOfRagdoll(health, img)
		DrawCenterBox(dt,name,health,oxy,stats)		
		DrawEffectsBox(stats)		
		
		DrawKeyPressInfos()
	UiPop()		
end

function DrawCenterBox(dt,name,health,oxy,stats)
	UiPush() -- center block
		UiTranslate(200,0)			
		drawRect(0,0,450,190,0.6,.6,.6,1)	
		DrawNameBox(name)
		
		UiTranslate(0,64)					
		DrawOscilloscopes(dt,health,oxy)				
	UiPop()
	
	-- BPM --
	DrawBPM()
	
	-- O2 SpO2 --
	DrawOxygenSpO()
	
	-- OXYGEN critial --
	DrawOxygenCritical(oxy)
	
	-- Cause Of Death --
	if not stats.living then
		DrawCauseOfDeath(stats.causeOfDeath)
		DrawCauseOfDeathAdditionalInformation(stats)
	end
end

function DrawSurroundingBackgroundBox()
	UiPush()
		UiTranslate(-10,-10)
		UiColor(0,0,0)	
		UiImageBox("ui/common/box-outline-fill-6.png",790,210,6,6)
	UiPop()
end

function DrawPhotoOfRagdoll(health, img)
	
	if health > 0 then
		UiColor(0.3,.3,.3,1)	
	else
		UiColor(0.5,0,0,1)	
	end		
	UiRect(200,190)		

	UiPush()
		if health > 0 then
			UiColor(1,1,1)	
		else
			UiColor(1,0,0,0.8)	
		end
		UiTranslate(100,95)
		UiAlign("middle, center")
		UiImageBox(img,180,170)		
	UiPop()
end

function DrawNameBox(name)
	UiPush()
		UiAlign("top center")
		UiTranslate(225,20)	
		UiColor(0,0,0)
		UiScale(0.95,1)
		UiFont("bold.ttf",30)
		UiText(name)
	UiPop()
end

function DrawEffectsBox(stats)
	UiPush()
		UiTranslate(650,0)	
		UiColor(0.8,.8,.8,1)
		UiRect(120,190)
		UiTranslate(60,10)	
		UiAlign("top center")
		UiColor(0,0,0)		
		UiFont("bold.ttf",24)
		UiText("EFFECTS")
		
		UiTranslate(0,25)			
		if stats.morphine then
			UiColor(1,1,1)		
			UiImageBox("MOD/imgs/Morphine.PNG",40,40,0,0)			
			textStyle("top center", 0, 0, 1, 1)							
			writeText("MORPHINE",12,0,30, true)
		end
		UiTranslate(0,50)			
		if stats.adrenaline then
			UiColor(1,1,1)		
			UiImageBox("MOD/imgs/Adrenaline.png",80,40,0,0)
			textStyle("top center", 0, 0.7, 0, 1)							
			writeText("ADRENALINE",12,0,30, true)
		end
		UiTranslate(0,50)			
		if stats.medkit then
			UiColor(1,1,1)		
			UiImageBox("MOD/imgs/Medkit.PNG",70,40,0,0)
			textStyle("top center", 1, 0, 0, 1)							
			writeText("MEDKIT",12,0,35, true)
		end
	UiPop()
end

function DrawOscilloscopes(dt,health,oxy)
	UiPush()		
		UiScale(0.75,0.5)					
		DrawHealth(dt,health)			
		UiTranslate(0,127)			
		DrawOxygen(dt,health,oxy)			
	UiPop()

	--- grey divider line between both oscilloscopes --
	UiPush()	
		UiTranslate(0,63)
		UiRect(450,3)
	UiPop()
end

function DrawHealth(dt,health)
	if health > 90 then
		drawHeartbeatOscillograph(dt,500, heartbeatImage)
	elseif health > 0 then
		drawFastHeartbeatOscillograph(dt,500, heartbeatImage)
	else
		drawFlatline(dt,500,0,1,0)
	end
	UiPush()				
		drawRect(499,1,100,126,0,0.1,0,1) -- backGround of Health
		textStyle("top center", 0, 1, 0, 1)				
		UiTranslate(548,0)				
		writeText("HEALTH",24,0,10, true)				
		UiScale(0.8,1.3)		
		if health <= 90 then UiColor(1,1,0) end
		if health <= 80 then UiColor(1,0,0) end	
		writeText(health,48,0,28,true)
		if health <= 80 then writeText("CRIT",30,0,64,true) end
	UiPop()
end

function DrawOxygen(dt,health,oxy)
	if health > 90  and oxy > 90 then
		drawHeartbeatOscillograph(dt,500, oxygenImage)
	elseif health > 0 and oxy > 0 then
		drawFastHeartbeatOscillograph(dt,500, oxygenImage)
	else
		drawFlatline(dt,500,0,0.7,1)
	end
							
	UiPush()				
		drawRect(499,1,100,126,0,0.1,0,1) -- backGround of Oxygen
		textStyle("top center", 0, 1, 0, 1)				
		UiTranslate(548,0)				
		writeText("OXYGEN",24,0,10, true)				
		UiScale(0.8,1.3)
		if oxy <= 20 then UiColor(1,0,0) end
		writeText(oxy,48,0,28,true)
		if oxy <= 20 then writeText("CRIT",30,0,64,true) end
	UiPop()
end


function DrawKeyPressInfos()

	UiTranslate(30,210)
	UiPush()		
		UiColor(1, 1 ,1, 1)				
		UiImageBox("ui/common/box-solid-6.png",26,26,4,4)
		UiColor(0, 0 ,0, 1)				
		UiFont("bold.ttf", 22)
		UiAlign("middle center")
		UiTranslate(13, 13)			
		UiText("X") 
		UiTranslate(30, 0)		
		UiAlign("middle left")		
		UiText("Toggle X-RAY")
	UiPop()
	UiTranslate(540,0)
	UiPush()		
		UiColor(1, 1 ,1, 1)				
		UiImageBox("ui/common/box-solid-6.png",26,26,4,4)
		UiColor(0, 0 ,0, 1)				
		UiFont("bold.ttf", 22)
		UiAlign("middle center")
		UiTranslate(13, 13)			
		UiText("H") 
		UiTranslate(30, 0)		
		UiAlign("middle,left")		
		UiText("Pin Stats")
	UiPop()
end

function DrawBPM()
	UiPush()
		UiTextOutline(0,1,0,1,0.1)
		textStyle("top left", 0, 1, 0, 1)
		writeText("BPM","16", 200, 66)				
	UiPop()
end

function DrawOxygenSpO()
	UiPush()
		UiTextOutline(0,0.7,1,1,0.1)
		textStyle("top left", 0, 0.7, 1, 1)
		writeText("O  SpO","16", 200, 132)				
	UiPop()
	UiPush()		
		UiTextOutline(0,0.7,1,1,0.1)
		textStyle("top left", 0, 0.7, 1, 1)
		writeText("2              2","10", 209, 138)				
	UiPop()
end

function DrawOxygenCritical(oxy)
	if oxy <= 20 then
		UiPush()
			UiTextOutline(1,0,0,1,0.1)
			textStyle("top center", 1, 0, 0, 1)
			writeText("OXYGEN CRITICAL",20, 400, 134)				
		UiPop()
	end
end

function DrawCauseOfDeath(causeOfDeath)
	UiPush()
		UiTextOutline(1,0,0,1,0.1)
		textStyle("top center", 1, 0, 0, 1)
		writeText("CAUSE OF DEATH: " .. causeOfDeath,20, 400, 70)				
	UiPop()
end

function DrawCauseOfDeathAdditionalInformation(stats)
	UiPush()
		UiTextOutline(1,0,0,1,0.1)
		textStyle("top center", 1, 0, 0, 1)
		if stats.playerInteraction then
			writeText("LIKELY KILLED BY PLAYER",20, 400, 100)				
		elseif stats.deathByTtripping then
			writeText("BLUNT TRAUMA",20, 400, 100)				
		end	
	UiPop()		
end

function drawHeartbeatOscillograph(dt,width,oscillographBackroundImage)		
	oscillographicShift = (oscillographicShift + dt*oscillographSpeed) % (885-355)
	UiPush()		
		UiWindow(width,125,true)
		UiImageBox(oscillographBackroundImage,885,126,0,0)
		UiPush()
			UiTranslate(oscillographicShift,0)
			UiImageBox(heartbeatMask,335,126,0,0)
		UiPop()
		UiPush()
			UiTranslate(oscillographicShift-(885-355),0)
			UiImageBox(heartbeatMask,335,126,0,0)
		UiPop()
	UiPop()
end

function drawFastHeartbeatOscillograph(dt,width,oscillographBackroundImage)		
	oscillographicShift = (oscillographicShift + dt*oscillographSpeed) % (885-355)
	UiPush()		
		UiWindow(width,125,true)
		UiPush()
			UiScale(0.6,1)
			UiImageBox(oscillographBackroundImage,885,126,0,0)
		UiPop()
		UiPush()
			UiTranslate(oscillographicShift,0)
			UiImageBox(heartbeatMask,335,126,0,0)
		UiPop()
		UiPush()
			UiTranslate(oscillographicShift-(885-355),0)
			UiImageBox(heartbeatMask,335,126,0,0)
		UiPop()
	UiPop()
end

function drawFlatline(dt,width,r,g,b)		
	oscillographicShift = (oscillographicShift + dt*oscillographSpeed) % (885-355)
	UiPush()		
		UiWindow(width,125,true)
		drawRect(0,0,885,126,0,0,0,1)			
		UiPush()		
			drawRect(0,61,885,4,r,g,b,1)			
		UiPop()
		UiPush()
			UiTranslate(oscillographicShift,0)
			UiImageBox(heartbeatMask,335,126,0,0)
		UiPop()
		UiPush()
			UiTranslate(oscillographicShift-(885-355),0)
			UiImageBox(heartbeatMask,335,126,0,0)
		UiPop()
	UiPop()
end

--- HELPER FUNCTIONS ---

function drawRect(x,y,w,h,r,g,b,a)
	UiPush()
		UiColor(r,g,b,a)
		UiTranslate(x,y)
		UiRect(w,h)
	UiPop()
end

function textStyle(align, r,g,b,a)
	UiAlign(align)
	UiColor(r, g, b, a)			
end

function writeText(text, size, x,y ,bold)
	UiPush()
		UiTranslate(x,y)
		if bold then
			UiFont("bold.ttf", size)
		else
			UiFont("regular.ttf", size)
		end
		UiText(text)
	UiPop()
end
