function init()
	mainBox = FindShape("mainBox")
	miniBox = FindShape("miniBox")
	
	soundBox = FindShapes("snd", true)
	
	mainFireScreen = FindScreen("mainFireScreen")
	miniFireScreen = FindScreen("miniFireScreen")
	
	
	trigger = FindTrigger("fireDetection")
	triggerMin, triggerMax = GetTriggerBounds(trigger)
	
	smokeDetectors = FindLights("smokel", true)
	alarmSound = LoadSound("MOD/main/realistic_house/fire alarm/snd/firealarm.ogg")
	beepTimer = 0
	flashTimer = 0
	resetTimer = 0
	SetBool("level.firealarm_reset", false)
end

function tick(dt)
	isFireActive = GetBool("level.firealarm")
	silenced = GetBool("level.firealarm_silenced")
	reset = GetBool("level.firealarm_reset")
	test = GetBool("level.firealarm_test")
	SetInt("level.fireCount", QueryAabbFireCount(triggerMin, triggerMax))
	fireCount = GetInt("level.fireCount")
	--DebugPrint(fireCount)
	
	if fireCount >= 5 then
		SetBool("level.firealarm", true)
	end
	if IsShapeBroken(mainBox) then
		SetBool("level.firealarm", false)
	end
	
	if reset then
		resetTimer = resetTimer + dt
	else
		resetTimer = 0
	end
	
	if resetTimer >= 3 then
		SetBool("level.firealarm_reset", false)
	end


	if isFireActive or test then
		beepTimer = beepTimer + dt
		flashTimer = flashTimer + dt
		if beepTimer >= 4 then
			if not silenced then
				for i=1,#soundBox do
					PlaySound(alarmSound, GetShapeWorldTransform(soundBox[i]).pos, 1)
				end
			end
			beepTimer = 0+dt
		end
	end
	for i=1,#smokeDetectors do
		if flashTimer >= 0.8 then
			if not silenced then
				SetLightEnabled(smokeDetectors[i], true)
			end
		else
			SetLightEnabled(smokeDetectors[i], false)
		end
		if flashTimer >= 1.005 then
			flashTimer = 0+dt
		end
	end
	
	if GetPlayerScreen() == 0 then
		SetTag(mainBox, "interact", "Main Fire System Control")
		SetTag(miniBox, "interact", "Fire Detection Status")
	else
		RemoveTag(mainBox, "interact")
		RemoveTag(miniBox, "interact")
	end
	
	if HasTag(mainBox, "interact") then
		if GetPlayerInteractShape() == mainBox and InputPressed("interact") then
			SetPlayerScreen(mainFireScreen)
		end
	end
	if HasTag(miniBox, "interact") then
		if GetPlayerInteractShape() == miniBox and InputPressed("interact") then
			SetPlayerScreen(miniFireScreen)
		end
	end
	
end