#include "library.lua"


function init()

    if not GetBool("NoLocalBranch") then

        updateVersion = "0.6.3"
        
        localJointTable = {}
        empty = {}
        diggerInfo = {}
        vehicleOperationList = {}
        lightSigal = true
        remote = false
        remoteDrive = false
        healthFade = 0

        updateInfo = false

        pathKey = "savegame.mod.key."
        pathUi = "savegame.mod.ui."
        
        ---- Setup ----

        setupKey = {}
        setupKey[#setupKey+1] = {"menu", "f3"}
        setupKey[#setupKey+1] = {"remote", "f9"}
        setupKey[#setupKey+1] = {"lightMode", "M"}
        setupKey[#setupKey+1] = {"headLight", "L"}
        setupKey[#setupKey+1] = {"lightSignal", "K"}
        setupKey[#setupKey+1] = {"beacon", "P"}
        setupKey[#setupKey+1] = {"warning", "O"}
        setupKey[#setupKey+1] = {"additional", "I"}
        setupKey[#setupKey+1] = {"blinkerR", "."}
        setupKey[#setupKey+1] = {"blinkerL", ","}
        setupKey[#setupKey+1] = {"siren", "U"}
        setupKey[#setupKey+1] = {"horn", "H"}

        setupUi = {}
        setupUi[#setupUi+1] = {"autoHide", "bool", false}
        setupUi[#setupUi+1] = {"autoHideTime", "float", 1}
        setupUi[#setupUi+1] = {"hookAssist", "bool", false}
        setupUi[#setupUi+1] = {"interAssist", "bool", true}
        setupUi[#setupUi+1] = {"showUpdate", "bool", true}
        setupUi[#setupUi+1] = {"help", "bool", true}
        

        if not GetBool("savegame.mod.initial") then
            
            for i=1, #setupKey do
                SetString(pathKey..setupKey[i][1], setupKey[i][2])
            end

            for i=1, #setupUi do
                if setupUi[i][2] == "bool" then
                    SetBool(pathUi..setupUi[i][1], setupUi[i][3])
                elseif setupUi[i][2] == "float" then
                    SetFloat(pathUi..setupUi[i][1], setupUi[i][3])
                elseif setupUi[i][2] == "string" then
                    SetString(pathUi..setupUi[i][1], setupUi[i][3])
                else
                    SetInt(pathUi..setupUi[i][1], setupUi[i][3])
                end
            end

            SetBool("savegame.mod.initial", true)
        end

        ---- Regular ----


        uiKeys = {}
        uiKeys[#uiKeys+1] = GetString(pathKey.."menu")
        uiKeys[#uiKeys+1] = GetString(pathKey.."remote")

        lightKeys = {}
        lightKeys[#lightKeys+1] = GetString(pathKey.."lightMode")
        lightKeys[#lightKeys+1] = GetString(pathKey.."headLight")
        lightKeys[#lightKeys+1] = GetString(pathKey.."lightSignal")
        lightKeys[#lightKeys+1] = GetString(pathKey.."beacon")
        lightKeys[#lightKeys+1] = GetString(pathKey.."warning")
        lightKeys[#lightKeys+1] = GetString(pathKey.."additional")
        lightKeys[#lightKeys+1] = GetString(pathKey.."blinkerL")
        lightKeys[#lightKeys+1] = GetString(pathKey.."blinkerR")

        honksCtrl = {}
        honksCtrl[#honksCtrl+1] = GetString(pathKey.."siren")
        honksCtrl[#honksCtrl+1] = GetString(pathKey.."horn")


        hookConnect = false
        storage = false
        
        newDoorsInit = FindBodies("Ydoor", true)
        newHoodsInit = FindBodies("Yhood", true)

        lightShapes = FindShapes("Ylight", true)
        honksInit = FindShapes("Yhorn", true)

        for i=1, #honksInit do
            if HasTag(GetBodyVehicle(GetShapeBody(honksInit[i])), "Auto") then
                SetTag(honksInit[i], "Ysiren")
            end
        end

        
        sirenList = {}
        sirenList[#sirenList+1] = LoadLoop("MOD/snd/siren01.ogg")
        sirenList[#sirenList+1] = LoadLoop("MOD/snd/siren02.ogg")
        sirenList[#sirenList+1] = LoadLoop("MOD/snd/siren03.ogg")
        sirenList[#sirenList+1] = LoadLoop("MOD/snd/siren04.ogg")
        sirenList[#sirenList+1] = LoadLoop("MOD/snd/siren05.ogg")
        sirenList[#sirenList+1] = LoadLoop("MOD/snd/siren06.ogg")
        sirenList[#sirenList+1] = LoadLoop("MOD/snd/siren07.ogg")

        honkList = {}
        honkList[#honkList+1] = LoadLoop("MOD/snd/honk01.ogg")
        honkList[#honkList+1] = LoadLoop("MOD/snd/honk02.ogg")
        honkList[#honkList+1] = LoadLoop("MOD/snd/honk03.ogg")
        honkList[#honkList+1] = LoadLoop("MOD/snd/honk04.ogg")
        honkList[#honkList+1] = LoadLoop("MOD/snd/honk05.ogg")
        honkList[#honkList+1] = LoadLoop("MOD/snd/honk06.ogg")
        honkList[#honkList+1] = LoadLoop("MOD/snd/honk07.ogg")


        interAssist = GetBool(pathUi.."interAssist")
        showUpdate = GetBool(pathUi.."showUpdate")

        YLVFVehicles = FindVehicles("YLVF", true)

        for v=1, #YLVFVehicles do
            if GetTagValue(YLVFVehicles[v], "nodrive") == "mod" then
                
                RemoveTag(YLVFVehicles[v], "nodrive")
                local t = 1

                repeat
                    if GetJointType(YLVFVehicles[v]+t) == "" and GetLightShape(YLVFVehicles[v]+t) == 0 and GetBodyShapes(YLVFVehicles[v]+t) ~= empty then
                        if GetShapeBody(YLVFVehicles[v]+t) == 0 then
                            check = GetBodyVehicle(YLVFVehicles[v]+t) ~= YLVFVehicles[v] and GetBodyVehicle(YLVFVehicles[v]+t) ~= 0
                            SetDescription(YLVFVehicles[v]+t, "")
                        else
                            if GetBodyVehicle(GetShapeBody(YLVFVehicles[v]+t)) == YLVFVehicles[v] then
                                SetDescription(YLVFVehicles[v]+t, "")
                            end
                        end
                    end
                    t = t + 1

                until (check or t>5000)
            end
        end
 
        RoutingLocations = FindLocations("Routing", true)

        RoutingList = {}
        maxGroup = 0

        for i=1, #RoutingLocations do
            maxGroup = math.max(maxGroup, tonumber(GetTagValue(RoutingLocations[i], "Routing")))
        end

        for g=1, maxGroup do
            table.insert(RoutingList, {})
        end

        for i=1, #RoutingLocations do
            local group = tonumber(GetTagValue(RoutingLocations[i], "Routing"))

            if RoutingList[group] ~= nil then
                table.insert(RoutingList[group], RoutingLocations[i])
            end
        end

        vec1 = Vec(0, 0, -1)
        vec2 = Vec(-1, 0, 0)
        VecH = Vec(0, 0.8, 0)
    
    end
end


function tick(df)

    RoutingVehicles = FindVehicles("Auto", true)

    if not GetBool("NoLocalBranch") then 
        NewDoor("open", "close", newDoorsInit)
        NewHood("open", "close", newHoodsInit)

        lightControl(lightKeys, remote, remoteDrive)
        lightOperate(lightShapes)

        honkNsiren(honksInit, sirenList, honkList, honksCtrl)
    end

    for i=1, #RoutingVehicles do
        local vehicle = RoutingVehicles[i]
        local vehicleTrans = GetVehicleTransform(vehicle)
        local vehicleSpeed = -TransformToLocalVec(vehicleTrans, GetBodyVelocity(GetVehicleBody(vehicle)))[3]
        
        local vehiclePos = vehicleTrans.pos
        local vehicleHPos = VecAdd(vehiclePos, TransformToParentVec(vehicleTrans, Vec(0, 1, 0)))
        local routingGroup = tonumber(GetTagValue(vehicle, "Auto"))
        local vehicleLength = tonumber(GetTagValue(vehicle, "Length")) or 1
        local direction = Vec(0, 0, 0)

        if not HasTag(vehicle, "Dest") then SetTag(vehicle, "Dest", "0") end

        for q=1, #RoutingList[routingGroup] do
            local location = RoutingList[routingGroup][q]
            local currentDest = tonumber(GetTagValue(vehicle, "Dest"))
            local currentQueue = tonumber(GetTagValue(location, "Queue"))
            local maxQueue = #RoutingList[routingGroup]
            local speedLimit = tonumber(GetTagValue(location, "SpeedLimit")) or 0
            local minDist = 20

            if HasTag(location, "NoStop") then
                if tonumber(GetTagValue(location, "NoStop")) ~= nil then
                    minDist = tonumber(GetTagValue(location, "NoStop"))
                end
            else
                minDist = 1.6
            end

            local frontVec = VecAdd(vehicleHPos, TransformToParentVec(vehicleTrans, VecScale(vec1, vehicleLength)))
            local backVec = VecAdd(vehicleHPos, TransformToParentVec(vehicleTrans, VecScale(vec1, -vehicleLength)))
            local leftVec = VecAdd(vehicleHPos, TransformToParentVec(vehicleTrans, VecScale(vec2, 1)))
            local rightVec = VecAdd(vehicleHPos, TransformToParentVec(vehicleTrans, VecScale(vec2, -1)))

            local front = {}
            front.hit = {}
            front.dist = {}
            front.normal = {}
            front.shape = {}

            local back = {}
            back.hit = {}
            back.dist = {}
            back.normal = {}
            back.shape = {}

            if not HasTag(location, "End") then

                QueryRequire("large")
                QueryRejectVehicle(vehicle)
                local checkHit, checkPoint, checkNormal, checkShape = QueryClosestPoint(backVec, 1)
                QueryRequire("large")
                QueryRejectVehicle(vehicle)
                QueryRejectBody(GetShapeBody(checkShape))
                front.hit[1], front.dist[1], front.normal, front.shape[1] = QueryRaycast(frontVec, TransformToParentVec(vehicleTrans, Vec(-1, 0, 0)), 0.6, 0.3)
                QueryRequire("large")
                QueryRejectVehicle(vehicle)
                QueryRejectBody(GetShapeBody(checkShape))
                front.hit[2], front.dist[2], front.normal, front.shape[2] = QueryRaycast(frontVec, TransformToParentVec(vehicleTrans, Vec(-1, 0, -2.5)), math.max(1, vehicleSpeed*0.4), 0.3)
                QueryRequire("large")
                QueryRejectVehicle(vehicle)
                QueryRejectBody(GetShapeBody(checkShape))
                front.hit[3], front.dist[3], front.normal, front.shape[3] = QueryRaycast(frontVec, TransformToParentVec(vehicleTrans, Vec(0, 0, -1)), math.max(3.5, vehicleSpeed), 0.4)
                QueryRequire("large")
                QueryRejectVehicle(vehicle)
                QueryRejectBody(GetShapeBody(checkShape))
                front.hit[4], front.dist[4], front.normal, front.shape[4] = QueryRaycast(frontVec, TransformToParentVec(vehicleTrans, Vec(1, 0, -2.5)), math.max(1, vehicleSpeed*0.4), 0.3)
                QueryRequire("large")
                QueryRejectVehicle(vehicle)
                QueryRejectBody(GetShapeBody(checkShape))
                front.hit[5], front.dist[5], front.normal, front.shape[5] = QueryRaycast(frontVec, TransformToParentVec(vehicleTrans, Vec(1, 0, 0)), 0.6, 0.3)

                if HasTag(vehicle, "Reverse") then
                    QueryRequire("large")
                    QueryRejectVehicle(vehicle)
                    local checkHit, checkPoint, checkNormal, checkShape = QueryClosestPoint(backVec, 1)
                    QueryRequire("large")
                    QueryRejectVehicle(vehicle)
                    QueryRejectBody(GetShapeBody(checkShape))
                    back.hit[1], back.dist[1], back.normal, back.shape[1] = QueryRaycast(backVec, TransformToParentVec(vehicleTrans, Vec(-1, 0, 0)), 0.5, 0.3)
                    QueryRequire("large")
                    QueryRejectVehicle(vehicle)
                    QueryRejectBody(GetShapeBody(checkShape))
                    back.hit[2], back.dist[2], back.normal, back.shape[2] = QueryRaycast(backVec, TransformToParentVec(vehicleTrans, Vec(-1, 0, 2)), 1.2, 0.3)
                    QueryRequire("large")
                    QueryRejectVehicle(vehicle)
                    QueryRejectBody(GetShapeBody(checkShape))
                    back.hit[3], back.dist[3], back.normal, back.shape[3] = QueryRaycast(backVec, TransformToParentVec(vehicleTrans, Vec(0, 0, 1)), 2, 0.4)
                    QueryRequire("large")
                    QueryRejectVehicle(vehicle)
                    QueryRejectBody(GetShapeBody(checkShape))
                    back.hit[4], back.dist[4], back.normal, back.shape[4] = QueryRaycast(backVec, TransformToParentVec(vehicleTrans, Vec(1, 0, 2)), 1.2, 0.3)
                    QueryRequire("large")
                    QueryRejectVehicle(vehicle)
                    QueryRejectBody(GetShapeBody(checkShape))
                    back.hit[5], back.dist[5], back.normal, back.shape[5] = QueryRaycast(backVec, TransformToParentVec(vehicleTrans, Vec(1, 0, 0)), 0.5, 0.3)
                end
            end

            if currentQueue == currentDest then
                local locationPos = GetLocationTransform(location).pos
                local destDist = VecLength(VecSub(locationPos, vehiclePos))
                local LocDirection = TransformToLocalVec(vehicleTrans, VecNormalize(VecSub(locationPos, vehiclePos)))
                direction = Vec(-LocDirection[1], 0, -LocDirection[3])

                if destDist >= minDist then
                    braking = false

                    if speedLimit ~= 0 then
                        overspeed = vehicleSpeed > speedLimit
                    end

                    arriving = vehicleSpeed*1.5 > destDist and vehicleSpeed > 2.5
                    braking = arriving or overspeed

                    if destDist >= 20 then

                        braking = braking or front.hit[3]

                        if direction[1] < 0.1 and direction[1] > -0.1 and direction[3] < 0 then

                            local throttle = destDist/100
                            local correctSteer = math.max(0.5, math.abs(direction[1]*20))

                            if front.hit[3] then throttle = 0 end

                            if (front.hit[1] or front.hit[2]) and (front.hit[4] or front.hit[5]) then
                                DriveVehicle(vehicle, throttle, direction[1]*20, braking)
                            elseif front.hit[1] or front.hit[2] then
                                DriveVehicle(vehicle, throttle, -correctSteer, braking)
                            elseif front.hit[4] or front.hit[5] then
                                DriveVehicle(vehicle, throttle, correctSteer, braking)
                            else
                                DriveVehicle(vehicle, throttle, direction[1]*20, braking)
                            end

                        elseif direction[1]*direction[1] > 0.64 then

                            local throttle = math.max(0.3, destDist/200)
                            local correctSteer = math.max(0.5, math.abs(direction[1]))

                            if front.hit[3] then throttle = 0 end

                            
                            if (front.hit[1] or front.hit[2]) and (front.hit[4] or front.hit[5]) then
                                DriveVehicle(vehicle, throttle, direction[1], braking)
                            elseif front.hit[1] or front.hit[2] then
                                DriveVehicle(vehicle, throttle, -correctSteer, braking)
                            elseif front.hit[4] or front.hit[5] then
                                DriveVehicle(vehicle, throttle, correctSteer, braking)
                            else
                                DriveVehicle(vehicle, throttle, direction[1], braking)
                            end

                        else

                            local throttle = destDist/100
                            local correctSteer = math.max(0.5, math.abs(direction[1]))

                            if front.hit[3] then throttle = 0 end

                            
                            if (front.hit[1] or front.hit[2]) and (front.hit[4] or front.hit[5]) then
                                DriveVehicle(vehicle, throttle, direction[1], braking)
                            elseif front.hit[1] or front.hit[2] then
                                DriveVehicle(vehicle, throttle, -correctSteer, braking)
                            elseif front.hit[4] or front.hit[5] then
                                DriveVehicle(vehicle, throttle, correctSteer, braking)
                            else
                                DriveVehicle(vehicle, throttle, direction[1], braking)
                            end

                        end
                        RemoveTag(vehicle, "Reverse")
                    else
                        if direction[3] < 0 or HasTag(vehicle, "Reverse") then

                            local throttle = math.min(-0.2, direction[3]*destDist/25)
                            local correctSteer = math.max(0.5, math.abs(direction[1]))

                            if back.hit[3] then throttle = 0 end
                            
                            if (back.hit[1] or back.hit[2]) and (back.hit[4] or back.hit[5]) then
                                DriveVehicle(vehicle, throttle, -direction[1], braking)
                            elseif back.hit[1] or back.hit[2] then
                                DriveVehicle(vehicle, throttle, correctSteer, braking)
                            elseif back.hit[4] or back.hit[5] then
                                DriveVehicle(vehicle, throttle, -correctSteer, braking)
                            else
                                DriveVehicle(vehicle, throttle, -direction[1], braking)
                            end
                            
                            SetTag(vehicle, "Reverse")
                        else

                            local throttle = math.max(0.2, direction[3]*destDist/25)
                            local correctSteer = math.max(0.5, math.abs(direction[1]))

                            if front.hit[3] then throttle = 0 end
                            
                            if (front.hit[1] or front.hit[2]) and (front.hit[4] or front.hit[5]) then
                                DriveVehicle(vehicle, throttle, direction[1], braking)
                            elseif front.hit[1] or front.hit[2] then
                                DriveVehicle(vehicle, throttle, -correctSteer, braking)
                            elseif front.hit[4] or front.hit[5] then
                                DriveVehicle(vehicle, throttle, correctSteer, braking)
                            else
                                DriveVehicle(vehicle, throttle, direction[1], braking)
                            end

                        end
                        if HasTag(vehicle, "Reverse") and direction[1]*direction[1] <= 0.001 then
                            RemoveTag(vehicle, "Reverse")
                        end
                    end
                else
                    DriveVehicle(vehicle, 0, 0, true)
                    if true --[[may change into other unique conditions]] then
                        if HasTag(location, "NoSiren") then
                            for h=1, #honksInit do
                                if GetBodyVehicle(GetShapeBody(honksInit[h])) == vehicle then
                                    RemoveTag(honksInit[h], "Ysiren")
                                end
                            end
                        elseif HasTag(location, "Siren") then
                            for h=1, #honksInit do
                                if GetBodyVehicle(GetShapeBody(honksInit[h])) == vehicle then
                                    SetTag(honksInit[h], "Ysiren")
                                end
                            end
                        end
                        if HasTag(location, "End") then
                            if GetPlayerVehicle() == vehicle then
                                RemoveTag(vehicle, "Auto")
                            end
                        elseif currentDest >= maxQueue then
                            SetTag(vehicle, "Dest", 0)
                        else
                            SetTag(vehicle, "Dest", currentDest+1)
                        end
                    end
                end
            elseif currentDest >= maxQueue and not HasTag(location, "End") then
                DriveVehicle(vehicle, 0, 0, true)
                SetTag(vehicle, "Dest", 0)
            end
        end
    end

end

function draw()
    if not GetBool("NoLocalBranch") then        
        local newBody = GetPlayerPickBody()
        local ignoreShape = true
        if newBody ~= 0 then
            if HasTag(newBody, "Yinter") then
                if interAssist then
                    DrawBodyOutline(newBody, 1, 1, 1, 0.4)
                end
                UiPush()
                    UiFont("bold.ttf", 22)
                    local str = string.upper(GetString("game.input.grab")).." to "..GetTagValue(newBody, "Yinter")
                    local w = 16 + UiGetTextSize(str)
                    UiAlign("center middle")
                    UiTranslate(UiCenter(), UiMiddle()+400)
                    UiColor(0.8, 1, 1, 0.6)
                    UiImageBox("ui/common/box-solid-6.png", w, 34, 6, 6)
                    UiColor(0, 0, 0)
                    UiText(str)
                UiPop()
            end
        end
        

        if lightShapes ~= empty then lightShape = true end

        info = {}
        infostat = false
        uilight = false
        uilightex = false
        uiblinker = false
        uiadmain = false
        uiadmainex = false
        uibeacon = false

        if lightShape then
            for i=1, #lightShapes do
                if GetBodyVehicle(GetShapeBody(lightShapes[i])) == GetPlayerVehicle() or HasTag(GetBodyVehicle(GetShapeBody(lightShapes[i])), "engineOn") or HasTag(GetBodyVehicle(GetShapeBody(lightShapes[i])), "active") then
                    if GetTagValue(lightShapes[i], "Ylight") == "FM" then
                        infostat = true
                        uilight = true
                        lights = GetShapeLights(lightShapes[i])
                        if lights ~= empty then
                            uilightex = true
                        end
                    end
                    if GetTagValue(lightShapes[i], "Ylight") == "BR" or GetTagValue(lightShapes[i], "Ylight") == "BL" then
                        infostat = true
                        uiblinker = true
                    end
                    if GetTagValue(lightShapes[i], "Ylight") == "ADM" then
                        infostat = true
                        uiadmain = true
                        lights = GetShapeLights(lightShapes[i])
                        if lights ~= empty then
                            uiadmainex = true
                        end
                    end
                    if GetTagValue(lightShapes[i], "Ylight") == "BCN" then
                        infostat = true
                        uibeacon = true
                    end
                end
            end
        end
        if uilight then
            info[#info+1] = {lightKeys[1], "Light Mode"}
            if uilightex then
                info[#info+1] = {lightKeys[2], "Main Beam Headlights"}
                info[#info+1] = {lightKeys[3], "Light Signal"}
            end
        end
        if uiblinker then
            info[#info+1] = {lightKeys[7].." & "..lightKeys[8], "Left & Right Blinker"}
            info[#info+1] = {lightKeys[6], "Warning Lights"}
        end
        if uibeacon then
            info[#info+1] = {lightKeys[4], "Beacon"}
        end

        local hornSet = false
        local sirenSet = false

        if honksInit ~= empty then
            for i=1, #honksInit do
                if thisVehDetect(honksInit[i]) then
                    if not hornSet then
                        info[#info+1] = {honksCtrl[2], "Horn"}
                        hornSet = true
                    end
                    if string.len(GetTagValue(honksInit[i], "Yhorn")) == 4 and not sirenSet then
                        info[#info+1] = {honksCtrl[1], "Siren"}
                        sirenSet = true
                    end
                end
            end
        end
        if not infostat then
            info[#info+1] = {"NOTICE", "No Operable Lights Found"}
        end
        info[#info+1] = {"", ""}
        info[#info+1] = {string.upper(uiKeys[1]), "Collapse"}

        UiPush()
            if HasTag(GetPlayerVehicle(), "YLVF") or remote then
                if InputPressed(uiKeys[1]) then
                    uioption = not uioption
                end
                if not uioption then
                    local kw = 0
                    local vw = 0
                    for i=1, #info do
                        UiFont("bold.ttf", 22)
                        local w0 = UiGetTextSize(info[i][1])
                        UiFont("regular.ttf", 22)
                        local w1 = UiGetTextSize(info[i][2])
                        kw = math.max(kw,w0)
                        vw = math.max(vw,w1)
                    end
                
                    local uiwidth = kw + vw + 120
                    local uiheight = #info*26 + 55
                    if uiwidth <= 270 then uiwidth = 270 end

                    UiAlign("left")
                    UiTranslate(20, 20)
                    UiColor(0,0,0,0.4)
                    UiImageBox("ui/common/box-solid-6.png", uiwidth, uiheight, 6, 6)
                    UiTranslate(uiwidth*0.5, 24)
                    UiAlign("center middle")
                    UiColor(0.9, 0.9, 0.9)
                    UiFont("bold.ttf", 26)
                    UiText("Available Operations")
                    UiTranslate(-45-(uiwidth-270)*0.25, 36)
                    for i=1, #info do
                        UiFont("bold.ttf", 22)
                        UiAlign("right")
                        UiText(info[i][1])
                        UiTranslate(20, 0)
                        UiFont("regular.ttf", 22)
                        UiAlign("left")
                        UiText(info[i][2])
                        UiTranslate(-20, 26)
                    end
                else
                    UiAlign("left")
                    UiTranslate(20, 20)
                    UiColor(0,0,0,0.4)
                    UiImageBox("ui/common/box-solid-6.png", 190, 40, 6, 6)
                    UiTranslate(95, 20)
                    UiAlign("center middle")
                    UiColor(0.9, 0.9, 0.9)
                    UiFont("bold.ttf", 22)
                    UiText(string.upper(uiKeys[1]).." - YLVF Options")
                end
            end
        UiPop()
    end
end
