
uiPath = "savegame.mod.ui."

empty = {}
list = {}
lightStatus = {}
lightStatus[0] = {1, false, false, true, false, false, false, false, 0}
var1 = 0
fade0 = 0
fade1 = 0
atvsteer = 0


function JointMortorUnified(joint, speed, direction)
    local min, max = GetJointLimits(joint)
    if GetJointType(joint) == "hinge" then
        if direction == "max" then
            SetJointMotorTarget(joint, max, speed)
        else
            SetJointMotorTarget(joint, min, speed)
        end
    elseif GetJointType(joint) == "prismatic" then
        if direction == "max" then
            SetJointMotorTarget(joint, max, speed/math.pi)
        else
            SetJointMotorTarget(joint, min, speed/math.pi)
        end
    end
end

function NewDoor(open, close, doors)
    if HasTag(GetPlayerPickBody(), "Ydoor") then

        local door = GetPlayerPickBody()

        if InputPressed("grab") then
            if GetTagValue(door, "Yinter") == open then
                SetTag(door, "Yinter", close)
            elseif GetTagValue(door, "Yinter") == close then
                SetTag(door, "Yinter", open)
            end
        end
    end

    for i=1, #doors do
        local localdoors = GetBodyShapes(doors[i])

        if not HasTag(doors[i], "Yinter") then
            SetTag(doors[i], "Yinter", open)
        end

        if debug then DrawBodyOutline(doors[i], debuglineDoor[1], debuglineDoor[2], debuglineDoor[3], 1) end
        if debug and GetTagValue(doors[i], "Ydoor") == "driver" then DrawBodyHighlight(doors[i], 0.7) end

        for t=1, #localdoors do
            local doorJoints = GetShapeJoints(localdoors[t])

            if GetPlayerVehicle() == GetBodyVehicle(doors[i]) and GetPlayerVehicle() ~= 0 then
                for j=1, #doorJoints do
                    JointMortorUnified(doorJoints[j], 2, "min")
                end
                if GetTagValue(doors[i], "Ydoor") == "driver" then
                    SetTag(doors[i], "Yinter", close)
                    SetTag(doors[i], "Ydriver")
                else
                    SetTag(doors[i], "Yinter", open)
                end
            else
                if GetPlayerPickBody() == doors[i] or HasTag(doors[i], "Yactive") or HasTag(doors[i], "Ydriver") or IsBodyActive(doors[i]) then
                    if GetTagValue(doors[i], "Yinter") == open then
                        local min, max = GetJointLimits(doorJoints[1])
                        if GetJointMovement(doorJoints[1]) >= min then
                            SetTag(doors[i], "Yactive")
                            for j=1, #doorJoints do
                                JointMortorUnified(doorJoints[j], 2, "min")
                            end
                        else
                            RemoveTag(doors[i], "Yactive")
                        end
                    elseif GetTagValue(doors[i], "Yinter") == close then
                        local min, max = GetJointLimits(doorJoints[1])
                        if GetJointMovement(doorJoints[1]) <= max then
                            SetTag(doors[i], "Yactive")
                            RemoveTag(doors[i], "Ydriver")
                            for j=1, #doorJoints do
                                JointMortorUnified(doorJoints[j], 2, "max")
                            end
                        else
                            RemoveTag(doors[i], "Yactive")
                        end
                    end
                end
            end
        end
    end
end

function NewHood(open, close, hoods)
    if HasTag(GetPlayerPickBody(), "Yhood") then

        local hood = GetPlayerPickBody()

        if InputPressed("grab") then
            if GetTagValue(hood, "Yinter") == open then
                SetTag(hood, "Yinter", close)
            elseif GetTagValue(hood, "Yinter") == close then
                SetTag(hood, "Yinter", open)
            end
        end
    end
       
    for i=1, #hoods do
        local localhoods = GetBodyShapes(hoods[i])

        if not HasTag(hoods[i], "Yinter") then
            SetTag(hoods[i], "Yinter", open)
        end

        if debug then DrawShapeOutline(hoods[i], debuglineHood[1], debuglineHood[2], debuglineHood[3], 1) end
        
        for t=1, #localhoods do
            local hoodJoints = GetShapeJoints(localhoods[t])
            
            if GetPlayerInteractShape() == hoods[i] or HasTag(hoods[i], "Yactive") or IsBodyActive(hoods[i]) then
                if GetTagValue(hoods[i], "Yinter") == open then
                    local min, max = GetJointLimits(hoodJoints[1])
                    if GetJointMovement(hoodJoints[1]) >= min then
                        SetTag(hoods[i], "Yactive")
                        for j=1, #hoodJoints do
                            JointMortorUnified(hoodJoints[j], 1.5, "min")
                        end
                    else
                        RemoveTag(hoods[i], "Yactive")
                    end
                elseif GetTagValue(hoods[i], "Yinter") == close then
                    local min, max = GetJointLimits(hoodJoints[1])
                    if GetJointMovement(hoodJoints[1]) <= max then
                        SetTag(hoods[i], "Yactive")
                        for j=1, #hoodJoints do
                            JointMortorUnified(hoodJoints[j], 1.5, "max")
                        end
                    else
                        RemoveTag(hoods[i], "Yactive")
                    end
                end
            end
        end
    end
end

function thisVehicle()
    if FindShape("Ylight", true) then
        lightShapes = FindShapes("Ylight", true)
        if GetPlayerVehicle ~= 0 or FindShape("Ylight", true) then
            for i=1, #lightShapes do
                if GetBodyVehicle(GetShapeBody(lightShapes[i])) == GetPlayerVehicle() then
                    var = true
                end
            end
        else
            var = false
        end
    end
    return var
end

function lightControl(inputList, condition1, condition2)

    local localVehicleOne = 0

    if GetPlayerVehicle() ~= 0 and HasTag(GetPlayerVehicle(), "YLVF") then
        localVehicleOne = GetPlayerVehicle()
    end

    if lightStatus[localVehicleOne] == nil then
        table.insert(lightStatus, localVehicleOne, lightStatus[0])
    end

    var1 = lightStatus[localVehicleOne][1]
    var2 = lightStatus[localVehicleOne][2]
    var3 = lightStatus[localVehicleOne][3]
    var4 = lightStatus[localVehicleOne][4]
    var5 = lightStatus[localVehicleOne][5]
    var6 = lightStatus[localVehicleOne][6]
    var7 = lightStatus[localVehicleOne][7]
    var8 = lightStatus[localVehicleOne][8]
    time = lightStatus[localVehicleOne][9]

    if GetPlayerVehicle() ~= 0 or condition2 then
        if not condition1 and condition2 then
        else
            if InputPressed(inputList[1]) then
                var1 = var1 + 1
                if var1 > 2 then var1 = 0 end
            end
            if InputPressed(inputList[2]) then
                var2 = not var2
            end
            var3 = InputDown(inputList[3])
            if InputPressed(inputList[4]) then
                var4 = not var4
            end
            if InputPressed(inputList[5]) then
                var5 = not var5
            end
            if InputPressed(inputList[6]) then
                var6 = not var6
                time = GetTime()
            end
            if InputPressed(inputList[7]) then
                var7 = not var7
                time = GetTime()
                if var7 then var8 = false end
            end
            if InputPressed(inputList[8]) then
                var8 = not var8
                time = GetTime()
                if var8 then var7 = false end
            end
            SetFloat("lightVar1", var1)
            SetBool("lightVar2", var2)
            SetBool("lightVar3", var3)
            SetBool("lightVar4", var4)
            SetBool("lightVar5", var5)
            SetBool("lightVar6", var6)
            SetBool("lightVar7", var7)
            SetBool("lightVar8", var8)
            SetFloat("lightTime", time)
        end
    end

    lightStatus[localVehicleOne] = {var1, var2, var3, var4, var5, var6, var7, var8, time}
end

function lightOperate(lightShapes)
    if lightShapes ~= empty then
        for i=1, #lightShapes do
            if debug then DrawShapeOutline(lightShapes[i], debuglineLight[1], debuglineLight[2], debuglineLight[3], 1) end

            tagValue = GetTagValue(lightShapes[i], "Ylight")
            lights = GetShapeLights(lightShapes[i])
            lightVehicle = GetBodyVehicle(GetShapeBody(lightShapes[i]))

            if lightStatus[lightVehicle] == nil then
                table.insert(lightStatus, lightVehicle, lightStatus[0])
            end

            statusList = lightStatus[lightVehicle]

            if tagValue == "FM" then

                if statusList[1] == 0 then
                    SetShapeEmissiveScale(lightShapes[i], 0)
                else
                    SetShapeEmissiveScale(lightShapes[i], 1)
                end
                for j=1, #lights do
                    if statusList[1] == 2 then
                        if statusList[2] or statusList[3] then
                            SetLightIntensity(lights[j], 200)
                        else
                            SetLightIntensity(lights[j], 10)
                        end
                    else
                        if statusList[3] then
                            SetLightIntensity(lights[j], 200)
                            SetShapeEmissiveScale(lightShapes[i], 1)
                        else
                            SetShapeEmissiveScale(lightShapes[i], 0)
                            SetLightIntensity(lights[j], 0)
                        end
                    end
                end

            elseif tagValue == "BR" then

                if statusList[6] or statusList[8] then
                    SetShapeEmissiveScale(lightShapes[i], math.cos((GetTime()-statusList[9])*9))
                    for j=1, #lights do
                        SetLightIntensity(lights[j], math.floor(-math.cos((GetTime()-statusList[9])*9)))
                    end
                else
                    SetShapeEmissiveScale(lightShapes[i], 0)
                    for j=1, #lights do
                        SetLightIntensity(lights[j], 0)
                    end
                end

            elseif tagValue == "BL" then

                if statusList[6] or statusList[7] then
                    SetShapeEmissiveScale(lightShapes[i], math.cos((GetTime()-statusList[9])*9))
                    for j=1, #lights do
                        SetLightIntensity(lights[j], math.floor(-math.cos((GetTime()-statusList[9])*9)))
                    end
                else
                    SetShapeEmissiveScale(lightShapes[i], 0)
                    for j=1, #lights do
                        SetLightIntensity(lights[j], 0)
                    end
                end

            elseif tagValue == "ADM" then

                if statusList[5] then
                    SetShapeEmissiveScale(lightShapes[i], 1)
                    for j=1, #lights do
                        if statusList[2] then
                            SetLightIntensity(lights[j], 400)
                        else
                            SetLightIntensity(lights[j], 10)
                        end
                    end
                else
                    SetShapeEmissiveScale(lightShapes[i], 0)
                    for j=1, #lights do
                        SetLightIntensity(lights[j], 0)
                    end
                end

            elseif tagValue == "BCN" then

                if statusList[4] then

                    for j=1, #lights do
                        SetLightIntensity(lights[j], 15)
                    end

                    if not initialTime then
                        timeInit = GetTime()
                        initialTime = true
                    end

                    deltTime = math.ceil(GetTime()*1.5-timeInit)

                    if GetTagValue(lightShapes[i], "Ylogic") == "1" then

                        SetShapeEmissiveScale(lightShapes[i], 3)
                        local joints = GetShapeJoints(lightShapes[i])
                        if GetPlayerVehicle() == GetBodyVehicle(GetShapeBody(lightShapes[i])) then
                            SetJointMotor(joints[1], 10)
                        else
                            SetJointMotor(joints[1], 0)
                        end

                    elseif GetTagValue(lightShapes[i], "Ylogic") == "20" then

                        if math.fmod(deltTime, 2) == 0 then
                            SetShapeEmissiveScale(lightShapes[i], 3)
                        else
                            SetShapeEmissiveScale(lightShapes[i], 0)
                            for j=1, #lights do
                                SetLightIntensity(lights[j], 0)
                            end
                        end

                    elseif GetTagValue(lightShapes[i], "Ylogic") == "30" then

                        if math.fmod(deltTime, 2) == 0 then
                            smalldeltTime = GetTime()*1.5 - deltTime
                            if math.fmod(smalldeltTime, 0.3) <= 0.2 then
                                SetShapeEmissiveScale(lightShapes[i], 3)
                            else
                                SetShapeEmissiveScale(lightShapes[i], 0)
                                for j=1, #lights do
                                    SetLightIntensity(lights[j], 0)
                                end
                            end
                        else
                            SetShapeEmissiveScale(lightShapes[i], 0)
                            for j=1, #lights do
                                SetLightIntensity(lights[j], 0)
                            end
                        end

                    elseif GetTagValue(lightShapes[i], "Ylogic") == "40" then

                        if math.fmod(deltTime, 2) == 0 then
                            if fade0 == 0 then
                                fade0 = 3
                            else
                                SetValue("fade0", 0, "linear", 0.4)
                            end
                        end
                        SetShapeEmissiveScale(lightShapes[i], fade0)
                        for j=1, #lights do
                            SetLightIntensity(lights[j], fade0*15)
                        end

                    elseif GetTagValue(lightShapes[i], "Ylogic") == "21" then

                        if math.fmod(deltTime, 2) == 1 then
                            SetShapeEmissiveScale(lightShapes[i], 3)
                        else
                            SetShapeEmissiveScale(lightShapes[i], 0)
                            for j=1, #lights do
                                SetLightIntensity(lights[j], 0)
                            end
                        end

                    elseif GetTagValue(lightShapes[i], "Ylogic") == "31" then

                        if math.fmod(deltTime, 2) == 1 then
                            smalldeltTime = GetTime()*1.5 - deltTime
                            if math.fmod(smalldeltTime, 0.3) <= 0.2 then
                                SetShapeEmissiveScale(lightShapes[i], 3)
                            else
                                SetShapeEmissiveScale(lightShapes[i], 0)
                                for j=1, #lights do
                                    SetLightIntensity(lights[j], 0)
                                end
                            end
                        else
                            SetShapeEmissiveScale(lightShapes[i], 0)
                            for j=1, #lights do
                                SetLightIntensity(lights[j], 0)
                            end
                        end

                    elseif GetTagValue(lightShapes[i], "Ylogic") == "41" then

                        if math.fmod(deltTime, 2) == 1 then
                            if fade1 == 0 then
                                fade1 = 3
                            else
                                SetValue("fade1", 0, "linear", 0.4)
                            end
                        end
                        SetShapeEmissiveScale(lightShapes[i], fade1)
                        for j=1, #lights do
                            SetLightIntensity(lights[j], fade1*15)
                        end
                    end
                else
                    for j=1, #lights do
                        SetLightIntensity(lights[j], 0)
                    end
                    
                    SetShapeEmissiveScale(lightShapes[i], 0)
                    if GetTagValue(lightShapes[i], "Ylogic") == "1" then
                        local joints = GetShapeJoints(lightShapes[i])
                        SetJointMotor(joints[1], 0)
                    end
                end
            end
        end
    end
end

function honkNsiren(sirenShapes, sirens, honks, ctrl)
    if sirenShapes ~= empty then
        for i=1, #sirenShapes do
            if not IsShapeBroken(sirenShapes[i]) and GetBodyVehicle(GetShapeBody(sirenShapes[i])) ~= 0 then
                if GetPlayerVehicle() == GetBodyVehicle(GetShapeBody(sirenShapes[i])) or HasTag(GetBodyVehicle(GetShapeBody(sirenShapes[i])), "Auto") then
                    if InputDown(ctrl[2]) and GetPlayerVehicle() == GetBodyVehicle(GetShapeBody(sirenShapes[i])) then
                        local x, y, z = GetShapeSize(sirenShapes[i])
                        local honkCentre = TransformToParentTransform(GetShapeWorldTransform(sirenShapes[i]), Transform(Vec(x/20, y/20, z/20)))
                        local honkNum = tonumber(string.sub(GetTagValue(sirenShapes[i], "Yhorn"), 1, 2))
                        PlayLoop(honks[honkNum], honkCentre.pos)
                    end
                    if HasTag(sirenShapes[i], "Ysiren") and not IsShapeBroken(sirenShapes[i]) then
                        local x, y, z = GetShapeSize(sirenShapes[i])
                        local honkCentre = TransformToParentTransform(GetShapeWorldTransform(sirenShapes[i]), Transform(Vec(x/20, y/20, z/20)))
                        local sirenNum = tonumber(string.sub(GetTagValue(sirenShapes[i], "Yhorn"), 3, 4))
                        PlayLoop(sirens[sirenNum], honkCentre.pos)
                    end
                    
                    if string.len(GetTagValue(sirenShapes[i], "Yhorn")) == 4 then
                        if GetPlayerVehicle() ~= 0 then
                            if InputPressed(ctrl[1]) then
                                if HasTag(sirenShapes[i], "Ysiren") then
                                    RemoveTag(sirenShapes[i], "Ysiren")
                                else
                                    SetTag(sirenShapes[i], "Ysiren")
                                end
                            end
                        else
                            if GetBool("YLVFremote") then
                                if InputPressed(ctrl[1]) then
                                    if HasTag(sirenShapes[i], "Ysiren") then
                                        RemoveTag(sirenShapes[i], "Ysiren")
                                    else
                                        SetTag(sirenShapes[i], "Ysiren")
                                    end
                                end
                            end
                        end
                    end
                end
            end
        end
    end
end

function thisVehDetect(shape)
    return GetBodyVehicle(GetShapeBody(shape)) == GetPlayerVehicle()
end
